val line_counter : int ref
type mutability = IN | OUT | INOUT
type type_spec = STRING | INT | INT_ARRAY of int | TUPLE 
type value = Init_integer of int32 | Init_string of string | Init_tuple of int32 * int32
type variable_description = {
  var_mutability : mutability;
  var_name : string;
  var_type : type_spec;
  var_init : value option;
}
type index = int
type variable = Var_atomic of string | Var_array of (string * index)

type test = {
  test_number : int;
  test_comment : string;
  test_inputs : (variable * value) list;
  test_results : (variable * value) list;
}
type shot = {
  tested_function : string;
  tested_parameters : variable_description list;
  tested_globvars : variable_description list;
  tested_tests : test list;
}
