let out_filemane = ref "out.c" ;;


let treat_file ~input: in_filename ~output: out_filename =
 let in_ch = open_in_bin in_filename in
 Basics.line_counter := 1 ;
 let lexbuf = Lexing.from_channel in_ch in
 let shot = TestParser.file TestLexer.token lexbuf in
 close_in in_ch ;
 let out_ch = open_out_bin out_filename in
 Generate.dump_c_file ~data: shot ~out_channel: out_ch ;
 close_out out_ch
;;



let main () =
  Arg.parse
    [("-o",
      Arg.String (fun fname -> out_filemane := fname ),
      "\n\t: " ^ Messages.msg_o_option) ]
    (fun fname ->
      treat_file ~input: fname ~output: !out_filemane)
    Messages.msg_help
;;


try
  main () ;
  exit 0
with
  | Parsing.Parse_error ->
      Printf.eprintf "%s\n" (Messages.msg_Syntax_error !Basics.line_counter) ;
      exit (-1)
  | Sys_error msg ->
      Printf.eprintf "%s\n" (Messages.msg_System_error msg) ;
      exit (-1)
  | Generate.Unitialised_variable var ->
      Printf.eprintf "%s.\n" (Messages.msg_Unitialised_variable var) ;
      exit (-1)
  | Generate.Variable_not_input var ->
      Printf.eprintf "%s.\n" (Messages.msg_Variable_not_input var) ;
      exit (-1)
  | Generate.Undefined_variable var ->
      Printf.eprintf "%s.\n" (Messages.msg_Undefined_variable var) ;
      exit (-1)
  | Generate.Type_mismatch var ->
      Printf.eprintf "%s.\n" (Messages.msg_Ty_mismatch_string_int var) ;
      exit (-1)
;;

      
